<template>
  <Popper
    ref="vuePopper"
    class="ob-tooltip"
    :options="{
      placement: position,
      modifiers: {
        offset: {
          offset: '0, 7'
        }
      }
    }"
    :transition="'fade-tooltip'"
    :disabled="disabled"
    :append-to-body="appendToBody"
    :delay-on-mouse-over="openDelay"
    :visible-arrow="!hideArrow"
    @show="$emit('input', true)"
    @hide="$emit('input', false)"
  >
    <div
      :class="[
        {
          '--primary': type === 'primary',
          '--error': type === 'error',
        },
        positionClass,
        popperClass
      ]"
      class="ob-tooltip__content"
    >
      <template v-if="$slots.content">
        <slot name="content" />
      </template>
      <template v-else>
        {{ content }}
      </template>
    </div>

    <div slot="reference">
      <slot />
    </div>
  </Popper>
</template>

<script>
import ClickOutside from 'vue-click-outside'
import { generateId } from '../../helpers/dom'
import Popper from 'vue-popperjs'
import 'vue-popperjs/dist/vue-popper.css'

export default {
  name: 'ObTooltip',
  directives: {
    ClickOutside
  },
  components: {
    Popper
  },
  props: {
    hideArrow: {
      type: Boolean,
      default: false
    },
    isHovered: {
      type: Boolean,
      default: false
    },
    content: {
      type: String,
      default: null
    },
    type: {
      type: String,
      default: 'primary'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      default: 'top'
    },
    appendToBody: {
      type: Boolean,
      default: true
    },
    popperClass: {
      type: String,
      default: null
    },
    openDelay: {
      type: Number,
      default: 300
    },
    value: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      transition: 'fade-tooltip',
      tooltipId: `ob-tooltip-${generateId()}`,
      localPopperOpt: {
        boundPadding: 5
      }
    }
  },
  computed: {
    positionClass () {
      return `--${this.position.split('-')[0]}`
    }
  },
  watch: {
    value: {
      immediate: true,
      handler (value) {
        this.$nextTick(() => {
          this.$refs.vuePopper && this.$refs.vuePopper[value ? 'doShow' : 'doClose']()
        })
      }
    }
  }
}
</script>

<style lang="scss">
  @import "../../static/css/variables";
  @import "../../static/css/mixins";

  @mixin popoverArrow {
    content: "";
    display: block;
    position: absolute;
    z-index: 9999;
    border-right: 4px solid transparent;
    border-left: 4px solid transparent;
    border-top: 4px solid $obTooltip-popoverArrow_border_top_color;
  }

  .ob-tooltip {
    display: inline-block;
    line-height: 1;
    border-radius: 2px;
    &__container {
      position: relative;
      z-index: 9999;
    }
    &__content {
      z-index: 9999;
      position: relative;
      padding: 8px 12px;
      max-width: 300px;
      min-width: 100px;
      background-color: $background-white;
      @include font-mixin(12px, 16px, 400, $cobalt-black);

      &.--primary {
        box-shadow: 0 0 8px rgba($color-blue-navy-blue, 0.4);
      }

      &.--error {
        box-shadow: 0 0 8px rgba($color-error, 0.4);
        color: $color-error;
      }

      .popper__arrow {
        @include popoverArrow;
      }
    }
    &__content[x-placement^="top"] .popper__arrow {
      bottom: -4px;
    }

    &__content[x-placement^="bottom"] .popper__arrow {
      top: -4px;
      transform: rotate(180deg);
    }

    &__content[x-placement^="right"] .popper__arrow {
      left: -6px;
      transform: rotate(90deg);
    }

    &__content[x-placement^="left"] .popper__arrow {
      right: -6px;
      transform: rotate(-90deg);
    }
  }
  .fade-tooltip-enter-active  {
    display: block;
    transition: opacity .3s;
  }
  .fade-tooltip-leave-active  {
    transition: opacity .3s;
    display: block;
  }
  .fade-tooltip-enter, .fade-tooltip-leave-to /* .fade-leave-active до версии 2.1.8 */ {
    opacity: 0;
  }
</style>

<!--&.&#45;&#45;top {-->
<!--transform: translate(0, -10px);-->
<!--}-->
<!--&.&#45;&#45;right {-->
<!--transform: translate(-10px, 0);-->
<!--}-->
<!--&.&#45;&#45;bottom {-->
<!--transform: translate(10px, 0);-->
<!--}-->
<!--&.&#45;&#45;left {-->
<!--transform: translate(0, -10px);-->
<!--}-->
